

function PrivacyGuard(elemId, activationDelay, headerMsg, bodyMsg, footerMsg) {
    this.elemId = elemId;
    this.activationDelay = activationDelay;
    this.headerMsg = headerMsg;
    this.bodyMsg = bodyMsg;
    this.footerMsg = footerMsg;
    this.elem = document.getElementById(elemId);
    if (this.elem) {
       this.elemWidth = this.elem.offsetWidth;
       this.elemHeight = this.elem.offsetHeight;
    }

    this.showGuard = function() {
        this.nextActivateTime = -1;
        this.elem = document.getElementById(elemId);
        if (this.elem) {
           this.elemWidth = this.elem.offsetWidth;
           this.elemHeight = this.elem.offsetHeight;
        }
        this.overlay = new YAHOO.widget.Overlay(this.elemId+"_overlay", { context:[this.elemId,"tl","tl"],visible:false,width:this.elemWidth+"px",height:this.elemHeight+"px",effect:{effect:YAHOO.widget.ContainerEffect.FADE,duration:0.25} } );
        this.overlay.setHeader("<span style='color:red; background-color: white; font-size: larger; font-weight:bold;'>"+headerMsg+"</span>");
        this.overlay.setBody("<span style='color:red; background-color: white; font-weight:bold;'>"+bodyMsg+"</span>");
        this.overlay.setFooter("<span style='color:red; background-color: white; font-weight:bold;'>"+footerMsg+"</span>");
        this.overlay.render(document.body);
        this.overlay.show();
    }

    this.mouseOverElem = function(e, obj) {
        obj.nextActivateTime = -1;
    }

    this.mouseOutElem = function(e, obj) {
        this.startTimer();
    }

    this.mouseOverGuard = function(e, obj) {
        obj.overlay.hide();
    }

    YAHOO.util.Event.addListener(this.elemId, "mouseover", this.mouseOverElem, this, true);
    YAHOO.util.Event.addListener(this.elemId, "mouseout", this.mouseOutElem, this, true);
    YAHOO.util.Event.addListener(this.elemId+"_overlay", "mouseover", this.mouseOverGuard, this, true);

    this.startTimer = function() {
        this.nextActivateTime = new Date().getTime() + this.activationDelay;
        this.checkGuardStatusTimer = setInterval("ActivateGuardIfNecessary('"+ this.elemId +"')", 2000);
    }

    this.cancelTimer = function() {
        if (this.checkGuardStatusTimer) {
            clearInterval(this.checkGuardStatusTimer);
        }
    }
}

function ActivateGuardIfNecessary(myid){
    var guard_obj_ns = myid+"_guard_var";
    var guard_obj = window[guard_obj_ns];
    if (guard_obj) {
        if (guard_obj.nextActivateTime<0) {
            return;
        }
        var timeNow = new Date().getTime();
        if (guard_obj.nextActivateTime <= timeNow) {
            //guard_obj.overlay.show();
            guard_obj.showGuard();
            guard_obj.cancelTimer();
        }
    } else {
        alert('privacy guard object reference not found ');
    }
}
